import json

import requests


def get_img_list(search_title):
    """
    获取图片list
    :return:
    """
    url = "https://lab.magiconch.com/api/baidu/images"
    params = {
        "text": search_title,
        "index": 0,
        "size": 60
    }
    headers = {
        'accept': '*/*',
        'accept-language': 'en,zh;q=0.9,zh-CN;q=0.8',
        'content-type': 'application/json',
        'cookie': 'Hm_lvt_f4e477c61adf5c145ce938a05611d5f0=1718784293; Hm_lpvt_f4e477c61adf5c145ce938a05611d5f0=1718784293',
        'if-none-match': 'W/"5e03-9dK2z/6rD0/7aX0R6HraLuFnLjI"',
        'priority': 'u=1, i',
        'referer': 'https://lab.magiconch.com/baidu-images/',
        'sec-ch-ua': '"Not/A)Brand";v="8", "Chromium";v="126", "Google Chrome";v="126"',
        'sec-ch-ua-mobile': '?0',
        'sec-ch-ua-platform': '"macOS"',
        'sec-fetch-dest': 'empty',
        'sec-fetch-mode': 'cors',
        'sec-fetch-site': 'same-origin',
        'user-agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Safari/537.36'
    }
    response = requests.request("GET", url, headers=headers, params=params)
    res = response.json()
    return res


title = "周总理巧解十二生肖!"
r = get_img_list(title)
for i in r:
    print(json.dumps(i, ensure_ascii=False, indent=4))
