import json

import pymysql

temp = {"text": "易中天，\n中国知名作家、教育家，\n央视《百家讲坛》开坛论道的学者，\n是国内当之无愧的国学大师。\n易老师是一位充满智慧之人，\n其白话式的幽默，以人讲事，以事说人，\n往往能一语中的，给观众留下深刻的印象。\n[image: https://mmbiz.qpic.cn/sz_mmbiz_jpg/xECA8rmz9PZuIoNVSIPbMBxVibH4y20QZibBph40T2ib0HhS1GQtjKn1F0z0LjUyhvolwVCu6TP5icXsyex0Gicejmw/640?wx_fmt=jpeg]\n博学而幽默的易老师，\n如今年过七十，退休生活过得有滋有味\n有人问他退休后该过怎样的生活？他的笑着做了一番回答，被无数人引为经典，整理成一篇文章与广大退休朋友分享。 \n退休后的生活，\n总离不开两个词：开心，舒坦\n。 \n我做教授这么多年，经历过不少的人情冷暖，也认识了很多的人。他们的遭遇或许不同，情感却大抵共通，大多数人的经验，总是值得借鉴与参考的。即将退休或者是已经退休的人，学着做到下面这几点，即使到了耄耋之年，仍能活得舒坦，活得潇洒，活得有尊严！ \n1、不求子女回报。\n我有一个女儿，我的教育方式就是“不教育”，我不期望她对我回报什么，我只期望我不要束缚了她。生养孩子，是我们的人生义务之一。对于儿女的付出，就不要指望他们会和你一样反馈回来。付出和回报不成正比，只有天下父母心。羊羔跪乳也是依旧在吸吮你的奶，它喂不成你。一定要省点奶养养自己。 \n2、养老根本靠自己。\n我今年73岁了，没有请保姆，养老完全靠自己。现在社会上多种养老方式，如老伴、新伴、子女、亲属、保姆、组织、社会等，分析的结果，根本的还是要靠自己。守住自己的老伴、老本、老窝和老友，同时有自己的兴趣、追求，这样你的老年生活才会丰富多彩。\n3、趁早享受。\n人生就这么几十年，好不容易来到这个世上，不借谁的、不欠谁的，挣多少就花多少，为啥要苦着自己、熬着自己呢？当你的牙好，腿好，身体也还行，趁着不聋不哑思维还清晰，品一下天下美味，看一看大好河山，四处走一走转一转，也不枉来世一遭。今天过去了，不会再有，我们应该珍惜每一天的生活。吃着了、喝着了，这一天过得就值，就不后悔！ \n4、儿孙自有儿孙福。\n儿女的生活不要去越俎代庖，儿孙自有儿孙福，他们是他们的一辈子，路是他们走，该撒手的必须撒手，让他们自己独立，你才能放下担子。不要劳心伤肺的为孩子的一些事情睡不着觉，就是不吃不睡，事情依然存在，不会有过不去的河，苍天饿不死天下麻雀，不要咸吃萝卜淡操心。 \n5、发展一门兴趣。\n我退休以后，喜欢写书法，这是我年轻时候就有的兴趣。趁年轻发展一门兴趣，给老了空巢做准备，等孩子离开家，也不至于一天到晚看着墙壁发呆。没有自己的精神寄托，那呆痴就会找你，这是必然的。 \n6、心疼自己。\n在心疼孩子的同时也心疼一下自己，孩子们再孝顺，感冒发烧你还得自己受，谁也替不了你。你觉得孩子是你身上掉下来的肉，但他们决不会觉得你是他们身上掉下来的肉，那是两个概念。自己年轻时没赶上好时候，生活困难，吃不起、穿不起，可是现在有了条件了，再舍不得吃，舍不得穿，就太糊涂了。 \n7、舍得给自己花钱。\n该给自己花一块的，决不去花八毛。你后半生的消费是有限的，没有必要对自己吝啬。再省也不会有人给你立牌坊，只会苦了自己。 \n8、不攀比，不计较。\n退休后，不去攀比，不去比较，大半辈子都过去了，什么都是浮云，你的存在就是最好，伸长了你的腿脚也占不了一两米地方。知足而乐就是当下，减少和压制自己的欲望。步入老年，看山是山，看水是水，没有什么事情特别稀奇。 \n[image: https://mmbiz.qpic.cn/sz_mmbiz_jpg/xECA8rmz9PZuIoNVSIPbMBxVibH4y20QZmUCBofHMz0tEgOk0kdUh61TZ6gUwyiaCqOUSmzc7gTkuSs5QFbzC6icQ/640?wx_fmt=jpeg]\n9、释放自己，享受喜悦。\n找上一两个挚友，放松自己，该说就说，该唱就唱，释放自己的一些郁闷，共同享受自己的喜悦，老来疯上一阵有何不可？没有人能够约束住你的精神，何乐而不为？年轻时的矜持可以一扫而光，只求精神的极大放松，自然、放松就是你身体正常运转的不二法宝。 \n10、不要硬撑。\n就算是一头驴，拉磨时间长了也得歇歇脚。到了一定年纪，任何事情都不硬着来。绳子断的时候就是在最细的地方出问题，如果觉得难受，不是休息就是找医生，决不坚持。 \n11、随遇而安。\n人生的路走过去了一大半，什么事情也是司空见惯，真理的概念有时候不见得是人多人少来认定的，没有必要去争上争下。该磨的棱角已经磨去，已经到了不好抓住你的时候，再让人抓住你的把柄，那你是真傻了。人老了，不是圆滑，是释然，不是老谋深算，是老成，是随遇而安。 \n12、吃补药不如一日三餐。\n不要相信那些养生的鬼把戏，吃什么补药都不如一日三餐安排妥当，酸辣稀稠自己找自己的感觉，不能让别人说了算。动物的任何自然规律你都存在，不是吃把药就能够长生不老，把钱花到不必要的地方去，还不如多吃点美味佳肴，落个嘴福。 \n13、坚持锻炼。\n任何锻炼都是循序渐进的，老了以后，锻炼就是相对消遣的事情，带有一定的娱乐性质，要适当消耗。不要认为你还可以和年轻人一比高下，最后趴下的是你，那就得不偿失。 \n14、尽量不生气。\n气是一只虎，抓肝又伤肚，只当它是屁，放了才舒服！生气有“四害”：血压变高，血脂变稠，血色变紫，血管变细。还可能引发脑塞，心肌梗死。所以，千万别生气。不要把有些事情放在心上，老了要有点滚刀肉的精神，不怕说，不怕议，不怕背后嚼舌头。任由他们去吧，我依然是我，开心快乐过！ \n15、有自己的生活信条。\n人生百年，不过是一个过程，好坏冷暖自知，想要潇洒就必须有自己的生活信条。不为他人所动，轻松自然地活着，就是你生命精彩的路径。 \n16、快乐永远是第一。\n一辈子很短，快乐就好。最人最重要的就是开心，学会宽容，不去计较。忘记名利，忘记恩怨，忘记烦恼。与人为善，不图回报，快乐来找。保持年轻心态，前半辈子努力换来后半辈子幸福生活。好好享受，别浪费大好时光。\n[image: https://mmbiz.qpic.cn/sz_mmbiz_png/xECA8rmz9PZuIoNVSIPbMBxVibH4y20QZDN4oOmibGJ3tUB1agD2ZtvYzAia9LdG8jwBbNKAd7qHN5ey67ibibhB8UQ/640?wx_fmt=png]\n正所谓：过一天，少一天；过一天，乐一天；乐一天，赚一天！\n退休后过这样的生活，人生才算没白活。\n不管你正当年轻，\n还是已过中年，\n做你应该做的事。\n如果你的生活\n以金钱为中心\n，你会活的\n很苦\n；\n如果你的生活\n以儿女为中心\n，你会活的\n很累\n；\n如果你的生活\n以爱情为中心\n，你会活的\n很伤\n；\n如果你的生活\n以攀比为中心\n，你会活的\n很苦闷\n；\n如果你的生活\n以宽容为中心\n，你会活的\n很幸福\n；\n如果你的生活\n以知足为中心\n，你会活的\n很快乐\n；\n如果你的生活\n以感恩为中心\n，你会活的\n很善良\n；\n[image: https://mmbiz.qpic.cn/sz_mmbiz_jpg/xECA8rmz9PZuIoNVSIPbMBxVibH4y20QZz9LWNfxupBakRB8psX0NMj94pkvBiboyIBQQ2ENW3ke1ht6faeQeBTw/640?wx_fmt=jpeg]\n做人\n：对上恭敬、对下不傲，是为礼；做事：大不糊涂、小不计较，是为智；对利：能拿六分，只拿四分，是为义；\n恪\n律\n：守身如莲，香远益清，是为廉；对人：表里如一，真诚以待，是为信；修心：优为聚灵，敬天爱人，是为仁。\n[image: https://mmbiz.qpic.cn/sz_mmbiz_jpg/xECA8rmz9PZuIoNVSIPbMBxVibH4y20QZ5nQeiciaSCZicUKG1LlWs0iaES8ZVGPoWuytXbl01UdWzZdMUCG1wsqFAw/640?wx_fmt=jpeg]\n在没钱的时候\n把勤舍得出去，钱就来了。\n一一\n这叫天道酬勤\n。\n在有钱的时候\n把钱舍得出去，人就来了。\n一一\n这叫财散人聚\n。\n当有人的时候\n把爱舍弃出去，事业就来了。\n一一\n这叫博爱领众\n。\n当事业成功后\n把智慧舍得出去，喜悦就来了。\n一一\n这叫德行天下\n。\n没有舍、就没有得！\n切记……世界是圆的，\n你怎么对别人，别人就怎么对你…\n[image: https://mmbiz.qpic.cn/sz_mmbiz_jpg/xECA8rmz9PZuIoNVSIPbMBxVibH4y20QZibsLYsH6V7Yxayxnhon5m6B2KFdaOkoN6Jrl0HjpPnJyq9pVLEUFUKw/640?wx_fmt=jpeg]", "title": "易中天对退休人的忠告，看了才没白活！受益无穷", "cover": "https://mmbiz.qpic.cn/sz_mmbiz_jpg/xECA8rmz9PZuIoNVSIPbMBxVibH4y20QZRWexIf59KK1ONwh9LCGHO6icICDptSNknF2VSgZ9vS0peJiceuz3mdibA/0?wx_fmt=jpeg", "img_list": ["https://mmbiz.qpic.cn/sz_mmbiz_jpg/xECA8rmz9PZuIoNVSIPbMBxVibH4y20QZRWexIf59KK1ONwh9LCGHO6icICDptSNknF2VSgZ9vS0peJiceuz3mdibA/0?wx_fmt=jpeg", "https://mmbiz.qpic.cn/sz_mmbiz_jpg/xECA8rmz9PZuIoNVSIPbMBxVibH4y20QZibBph40T2ib0HhS1GQtjKn1F0z0LjUyhvolwVCu6TP5icXsyex0Gicejmw/640?wx_fmt=jpeg", "https://mmbiz.qpic.cn/sz_mmbiz_jpg/xECA8rmz9PZuIoNVSIPbMBxVibH4y20QZmUCBofHMz0tEgOk0kdUh61TZ6gUwyiaCqOUSmzc7gTkuSs5QFbzC6icQ/640?wx_fmt=jpeg", "https://mmbiz.qpic.cn/sz_mmbiz_png/xECA8rmz9PZuIoNVSIPbMBxVibH4y20QZDN4oOmibGJ3tUB1agD2ZtvYzAia9LdG8jwBbNKAd7qHN5ey67ibibhB8UQ/640?wx_fmt=png", "https://mmbiz.qpic.cn/sz_mmbiz_jpg/xECA8rmz9PZuIoNVSIPbMBxVibH4y20QZz9LWNfxupBakRB8psX0NMj94pkvBiboyIBQQ2ENW3ke1ht6faeQeBTw/640?wx_fmt=jpeg", "https://mmbiz.qpic.cn/sz_mmbiz_jpg/xECA8rmz9PZuIoNVSIPbMBxVibH4y20QZ5nQeiciaSCZicUKG1LlWs0iaES8ZVGPoWuytXbl01UdWzZdMUCG1wsqFAw/640?wx_fmt=jpeg", "https://mmbiz.qpic.cn/sz_mmbiz_jpg/xECA8rmz9PZuIoNVSIPbMBxVibH4y20QZibsLYsH6V7Yxayxnhon5m6B2KFdaOkoN6Jrl0HjpPnJyq9pVLEUFUKw/640?wx_fmt=jpeg"]}
connection = pymysql.connect(
            host='rm-bp1159bu17li9hi94.mysql.rds.aliyuncs.com',
            port=3306,
            user='crawler',
            password='crawler123456@',
            db='piaoquan-crawler',
            charset='utf8mb4'
)

text = temp['text'].replace("\n", "")
title = temp['title']
cover = temp['cover']
img_list = temp['img_list']

sql = update_sql = f"""
UPDATE video_to_articles
SET ai_text = %s, ai_title = %s, cover = %s, img_list = %s, status_code = %s
WHERE task_id = %s;"""

cursor = connection.cursor()
cursor.execute(sql, (
    text,
    title,
    cover,
    json.dumps(img_list, ensure_ascii=False),
    3,
    "Article_6097463f-3cf6-48e5-9e3f-f32cd117514d_1720590638"
))
connection.commit()